// Agent.m
//---------------------------------------------------------------------
#import "Agent.h"
//--------------------------------------------------------------------
@implementation Agent
//--------------------------------------------------------------------
- createEnd
{
   int i;
   steps = sumProfit = 0;
   for(i=0;i<256;i++) oldProfit[i] = 0;
   return [super createEnd];
}
//--------------------------------------------------------------------
- setRuleMaster:    (CW_RuleMaster*)  rM {ruleMaster = rM;return self;}
- setShop:          (Shop *)          sh {shop = sh; return self;}
- setDataWarehouse: (id)              dW {dataWarehouse = dW;return self;}
- setInterface:     (id)              an {interface = an;return self;}
- setNumber:        (int)             nn {number = nn;return self;}
- setDirectCost:    (int)             dC {directCost = dC;return self;}
- setFixedCost:     (int)             fC {fixedCost = fC;return self;}
//--------------------------------------------------------------------
- (int) getPrice  {return price;}
- (int) getProfit {return profit;}
//--------------------------------------------------------------------
- fixNewPrice
{
   opponentPrice = [shop getPriceOf: (number+1)%2];
   [interface encode: opponentPrice];
   [ruleMaster applyRuleTo: (CW_DataWarehouse *) dataWarehouse
                      with: (id)                 interface];
   newPrice = [interface decode];
   return self;
}
//--------------------------------------------------------------------
- modifyPrice
{
   [shop setPriceOf: number to: newPrice];
   price = newPrice;
   return self;
}
//--------------------------------------------------------------------
- computeProfit
{
   sell = [shop getSellOf: number];
   profit = sell * (price - directCost) - fixedCost;
   [shop setProfitOf: number to: profit];
   return self;
}
//--------------------------------------------------------------------
- evaluateProfit
{
   double reward;

   secMean = [shop getSectorialMeanProfit];
   secMax  = [shop getSectorialMaxProfit];

   sumProfit = sumProfit - oldProfit[steps%100];
   sumProfit = sumProfit + profit;
   oldProfit[steps%100] = profit;
   steps++;
   if (steps > 100) meanProfit = sumProfit / 100;
   else             meanProfit = sumProfit / steps;

   if (profit > meanProfit) reward = 0.9;
   if (profit >= secMax)    reward = 1;

   reward = profit; //new

   [ruleMaster setReward: reward to: dataWarehouse];
   return self;
}
//--------------------------------------------------------------------
- print
{
   [dataWarehouse print];
   return self;
}
//--------------------------------------------------------------------
@end
