// CW_RuleMaker.m
//--------------------------------------------------------------------

#import "CW_RuleMaker.h"

@implementation CW_RuleMaker

//--------------------------------------------------------------------

- createEnd
{

   id obj;

TRACE6(printf("\n%8X RuleMaker - entry createEnd\n",(int) self);)

   eyeCatcher[0]='R';
   eyeCatcher[1]='M';
   eyeCatcher[2]='K';
   eyeCatcher[3]='R';
   obj = [super createEnd];

TRACE6(printf("%8X RuleMaker - exit createEnd %8X\n\n",
              (int) self,(int) obj);)

   return obj;

}

//--------------------------------------------------------------------

- setDump: (EH_Dump *) du
{

TRACE6(printf("\n%8X RuleMaker - entry setDump: %8X\n",
              (int) self,(int) du);)

   dump = du;

TRACE6(printf("%8X RuleMaker - exit setDump %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- setShuffler: (CW_Shuffler *) sh
{

TRACE6(printf("\n%8X RuleMaker - entry setShuffler: %8X\n",
              (int) self,(int) sh);)

   shuffler = sh;

TRACE6(printf("%8X RuleMaker - exit setShuffler %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- evolveDataWarehouse: (CW_DataWarehouse *) dW
{

   int i;
   double averageStrength;

TRACE6(printf("\n%8X RuleMaker - entry evolveDataWarehouse: %8X\n",
                 (int) self,(int) dW);)

   dataWarehouse = dW;

   [self keepData];

   for(i=0;i<couplesToSelect;i++)
   {

      child1  = [CW_Rule createBegin: [self getZone]];
      child1  = [child1 createEnd];
      [child1 setDump: dump];

      child2  = [CW_Rule createBegin: [self getZone]];
      child2  = [child2 createEnd];
      [child2 setDump: dump];


      do
      {
         parent1 = (CW_Rule *) self;
         parent1 = [self selectBest];
         parent2 = [self selectBest];

         [self crossAndMutate];

      } while ([self verify] != 0);

      averageStrength = ([parent1 getStrength] +
                        [parent2 getStrength]   ) /2;

      [child1 setTheUniformDblRand: aUniformDblRand];
      [child2 setTheUniformDblRand: aUniformDblRand];
      [child1 setLength: geneLength];
      [child2 setLength: geneLength];
      [child1 setStrength: averageStrength];
      [child2 setStrength: averageStrength];
      [child1 setCondition: &work1[0]];
      [child1 setAction: &work1[geneLength]];
      [child2 setCondition: &work2[0]];
      [child2 setAction: &work2[geneLength]];

      [self removeWorstMatching: child1];
      [self removeWorstMatching: child2];

      [ruleList addLast: child1];
      numberOfRules++;

      [ruleList addLast: child2];
      numberOfRules++;

      totalStrength = totalStrength + averageStrength * 2;

   }



TRACE6(printf("%8X RuleMaker - exit evolveDataWarehouse: %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- keepData
{

   int i=0;

TRACE6(printf("\n%8X RuleMaker - entry keepData\n",(int) self);)

   aUniformDblRand  = [dataWarehouse getUniformDblRand];
   aUniformIntRand  = [dataWarehouse getUniformIntRand];

   parmWarehouse    = [dataWarehouse getParmWarehouse];
   treasury         = (id) [dataWarehouse getTreasury];

   ruleList         = [dataWarehouse getRuleList];
   messageList      = [dataWarehouse getMessageList];

   if ([parmWarehouse getParm: "geneLength"
                  intoInteger: &geneLength] != 0)
   {
      printf("CW_RuleMaker cannot find geneLength\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "effectorsFlag"
                  intoInteger: &effectorsFlag] != 0)
   {
      printf("CW_RuleMaker cannot find effectorsFlag value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "wildCardRate"
                    intoFloat: &wildCardRate] != 0)
   {
      printf("CW_RuleMaker cannot find wildCardRate value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "turnoverRate"
                    intoFloat: &turnoverRate] != 0)
   {
      printf("CW_RuleMaker cannot find turnoverRate value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "crossoverRate"
                    intoFloat: &crossoverRate] != 0)
   {
      printf("CW_RuleMaker cannot find crossoverRate value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "mutationRate"
                    intoFloat: &mutationRate] != 0)
   {
      printf("CW_RuleMaker cannot find mutationRate value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "crowdingRate"
                    intoFloat: &crowdingRate] != 0)
   {
      printf("CW_RuleMaker cannot find crowdingRate value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "crowdingFactor"
                    intoFloat: &crowdingFactor] != 0)
   {
      printf("CW_RuleMaker cannot find crowdingFactor value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "verifyNews"
                  intoInteger: &verifyNews] != 0)
   {
      printf("CW_RuleMaker cannot find verifyNews value\n");
      i = 1;
   }

   if ([parmWarehouse getParm: "shuffleFlag"
                  intoInteger: &shuffleFlag] != 0)
   {
      printf("CW_RuleMaker cannot find shuffleFlag value\n");
      i = 1;
   }

   if (i != 0)
   {
      printf("CW_RuleMaker cannot find one or more parameters\n");
      exit (0);
   }

   numberOfRules    = [ruleList getCount];
   numberOfMessages = [messageList getCount];

   totalStrength  = 0;
   for (i=0;i<numberOfRules;i++)
      totalStrength = totalStrength +
                      [[ruleList atOffset: i] getStrength];

   couplesToSelect = (numberOfRules*turnoverRate*0.5);
   if (couplesToSelect < 1) couplesToSelect = 1;

TRACE6(printf("%8X RuleMaker - exit keepData %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- (CW_Rule *) selectBest
{

   int     i=0;
   double  randomStrength,sumStrength=0,s=0;
   CW_Rule * rule;

TRACE6(printf("\n%8X RuleMaker - entry selectBest\n",(int) self);)

   if (parent1 != (CW_Rule *) self) s = [parent1 getStrength];
   randomStrength =
      [aUniformDblRand getDoubleWithMin: 0 withMax: totalStrength-s];

   if (shuffleFlag == 1) [shuffler shuffle: ruleList
                                     using: aUniformIntRand];
   do
   {

      rule = [ruleList atOffset: i];
      if (rule != parent1)
         sumStrength = sumStrength + [rule getStrength];
      i++;

   } while ((sumStrength < randomStrength) 
            && (i < numberOfRules));

TRACE6(printf("%8X RuleMaker - exit selectBest %8X\n",
               (int) self,(int) rule);)

   return rule;

}

//--------------------------------------------------------------------

- crossAndMutate
{

   int i,j,xC=0,xA=0;
   char * string1;
   char * string2;
   char * string3;
   char * string4;
   char  allele[4];
   char  mutantAllele[4];

TRACE6(printf("\n%8X RuleMaker - entry crossAndMutate\n",(int) self);)

   string1 = [parent1 getCondition];
   string2 = [parent2 getCondition];
   string3 = [parent1 getAction];
   string4 = [parent2 getAction];

   if ([aUniformDblRand getDoubleWithMin: 0 withMax: 1]
       < crossoverRate)
   {

      xC = [aUniformIntRand getIntegerWithMin: 1 withMax: geneLength];
      xA = [aUniformIntRand getIntegerWithMin: 1 withMax: geneLength];

   }

   for(i=0;i<geneLength;i++)
   {

      allele[0] = mutantAllele[0] = string1[i];
      allele[1] = mutantAllele[1] = string2[i];
      allele[2] = mutantAllele[2] = string3[i];
      allele[3] = mutantAllele[3] = string4[i];

      for(j=0;j<4;j++)
      {

         if ([aUniformDblRand getDoubleWithMin: 0 withMax: 1]
             < mutationRate)
         {

            mutantAllele[j] = '#';
            if (allele[j] == '#') mutantAllele[j] = '0';
            if (allele[j] == '0') mutantAllele[j] = '1';

         }

      }

      if (i<xC)
      {

         work1[i] = mutantAllele[1];
         work2[i] = mutantAllele[0];

      }
      else
      {

         work1[i] = mutantAllele[0];
         work2[i] = mutantAllele[1];

      }

      if (effectorsFlag == 0)
      {

         if (i<xA)
         {

            work1[i+geneLength] = mutantAllele[3];
            work2[i+geneLength] = mutantAllele[2];

         }
         else
         {

            work1[i+geneLength] = mutantAllele[2];
            work2[i+geneLength] = mutantAllele[3];

         }

      }

   }

   if (effectorsFlag == 1)
   {

      for(i=0;i<geneLength;i++)
      {

         work1[i+geneLength] = string4[i];
         work2[i+geneLength] = string3[i];

      }

   }

TRACE6(printf("%8X RuleMaker - exit crossAndMutate %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- removeWorstMatching: (CW_Rule *) ch
{

   int        i,j,j2,j3,k,cR,cF,maxMatch=-1,match;
   double     worstStrength,aRuleStrength;
   CW_Rule    * aRule;
   CW_Message * message;
   CW_Rule    * worstRule;
   CW_Rule    * worstAndSimilarRule=nil;
   char       * childCondition;
   char       * childAction;
   char       * worstCondition;
   char       * worstAction=(char *)' ';

TRACE6(printf("\n%8X RuleMaker - entry removeWorstMatching: %8X\n",
              (int) self,(int) ch);)

   childCondition = [ch getCondition];
   childAction    = [ch getAction];

   cF = numberOfRules * crowdingFactor;
   cR = numberOfRules * crowdingRate;
   if (cF < 1) cF = 1;
   if (cR < 1) cR = 1;

   j=[aUniformIntRand getIntegerWithMin: 0 withMax: numberOfRules-1];

   for(i=0;i<cF;i++)
   {

     //      j=[aUniformIntRand getIntegerWithMin: 0 withMax: numberOfRules-1];
      worstRule     = [ruleList atOffset: j];
      worstStrength = [worstRule getStrength];
      j = (j+1)%numberOfRules;

         j2 =
        [aUniformIntRand getIntegerWithMin: 0 withMax: numberOfRules-1];

      for(k=0;k<cR;k++)
      {
	// j =
	// [aUniformIntRand getIntegerWithMin: 0 withMax: numberOfRules-1];

	//         aRule         = [ruleList atOffset: j];
         aRule         = [ruleList atOffset: j2];
         aRuleStrength = [aRule getStrength];
         j2 = (j2+1)%numberOfRules;

         if (aRuleStrength < worstStrength)
         {

            worstRule     = aRule;
            worstStrength = aRuleStrength;

         }

      }

      worstCondition = [worstRule getCondition];
      worstAction    = [worstRule getAction];

      match = 0;
      //      for(j=0;j<geneLength;j++)
      for(j3=0;j3<geneLength;j3++)
      {

         if (worstCondition[j3] == childCondition[j3]) match++;
         if (worstAction[j3]    == childAction[j3])    match++;

      }

      if (match > maxMatch)
      {

         worstAndSimilarRule = worstRule;
         maxMatch            = match;

      }

   }

   totalStrength = totalStrength -
                   [worstAndSimilarRule getStrength];

   [ruleList remove: worstAndSimilarRule];

   if (effectorsFlag == 1)
   {

      worstAction = [worstAndSimilarRule getAction];
      for(j=0;j<geneLength;j++) childAction[j] = worstAction[j];

   }

//If we are dropping a Rule that have an own message in current
//messageList we change the owner of the message to avoid storage
//violation if an other rule, matching this messages, will try to
//pay it's owner. If the rule has been dropped her reward will be
//cached by treasury.

   for(i=0;i<numberOfMessages;i++)
   {

      message = [messageList atOffset: i];
      if ([message getOwner] == (id) worstAndSimilarRule)
         [message setOwner: treasury];

   }

   [worstAndSimilarRule drop];
   numberOfRules--;

TRACE6(printf("%8X RuleMaker - exit removeWorstMatching %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- (int) verify
{

   int     i,j,match1=0,match2;
   CW_Rule * aRule;
   char    * condition;
   char    * action;

TRACE6(printf("\n%8X RuleMaker - entry verify\n",
              (int) self);)

   if (verifyNews == 0) return 0;
   for (i=0;i<geneLength*2;i++) if(work1[i] == work2[i]) match1++;
   if (match1 == geneLength*2)
   {

TRACE6(printf("%8X RuleMaker - exit verify 8\n\n",
              (int) self);)
      return 8;

   }

   for(i=0;i<numberOfRules;i++)
   {

      aRule = [ruleList atOffset: i];
      condition = [aRule getCondition];
      action    = [aRule getAction];
      match1 = match2 = 0;

      for (j=0;j<geneLength;j++)
      {

         if(work1[j] == condition[j]) match1++;
         if(work2[j] == condition[j]) match2++;
         if(work1[j+geneLength] == action[j]) match1++;
         if(work2[j+geneLength] == action[j]) match2++;

      }

      if ((match1 == geneLength*2) || (match2 == geneLength*2))
      {

TRACE6(printf("%8X RuleMaker - exit verify 4\n\n",
              (int) self);)
         return 4;

      }

   }

TRACE6(printf("%8X RuleMaker - exit verify 0\n\n",
              (int) self);)

   return 0;

}

//--------------------------------------------------------------------
@end
