// ModelSwarm.h
//--------------------------------------------------------------------
#import <objectbase/Swarm.h>
#import <objectbase.h>    // needed by <ProbeMap> in ModelSwarm.m
                          // in simpleObserverBug2 (and in langtonAntSpace)
                          // it is indirectly imported by space.h
#import <random.h>
#import "Shop.h"
#import "Customer.h"
#import "Agent.h"

#import "CW_DataWarehouse.h"
#import "CW_Interface.h"
#import "CW_RuleMaker.h"
#import "CW_RuleMaster.h"
#import "CW_Shuffler.h"
#import "PH_Reader.h"
#import "PH_ParmWarehouse.h"
#import "EH_Dump.h"
#import "EH_Trace.h"
//--------------------------------------------------------------------
@interface ModelSwarm: Swarm
{

   char eyeCatcher[4];
   id<List> agentList;
   id<List> customerList;
   Shop *   shop;
   id modelActions;
   id modelSchedule;
   int numberOfAgents,numberOfCustomers,maxPrice,directCost,fixedCost,
       memory;
   float substitutionRate;
}
//--------------------------------------------------------------------
+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- getAgentList;
- (int)   getMaxPrice;
- (float) getSubstitutionRate;
- (int)   getDirectCost;
- (int)   getFixedCost;
//--------------------------------------------------------------------
@end
