// PH_Reader.m
//--------------------------------------------------------------------
#import "PH_Reader.h"
@implementation PH_Reader
//--------------------------------------------------------------------
- createEnd
{
   fileStatus = 0;                                   //Reader available
   return [super createEnd];
}
//--------------------------------------------------------------------
- (int) openFile: (char*) fP
{
   //If fileStatus is not 0 another file is yet open - the reader is
   //not able to open again.

   if(fileStatus != 0) return -2;                    //Reader busy
   if((filePtr = fopen(fP,"r")) == NULL) return -1;  //File not found

   fileStatus = 1;                                   //Reader ready
   return 0;
}
//--------------------------------------------------------------------
- (int) readInto: (char*) bP withLength: (int) ll
{
   //The default rc is 2 that means row is truncated in assignement
   //this value will be changed in 0 if the '\n' end of row charachter
   //is found

   int i,rc=2;

   TRACEE(printf(">>> PH_Reader readInto\n\n");)

   if(fileStatus != 1) return -3;                    //No files open
   if(fgets(bP,ll,filePtr) == NULL) return 1;        //End Of File

   //Loop to find end of row - if found it will be removed and
   //the rc will be set to 0

   for(i=0;i<ll;i++) if(bP[i] == '\n')
   {
      bP[i] = '\0';                                  //Remove end row
      rc    = 0;                                     //set to 0 rc
   }

   bP[ll-1] = '\0';                                    //Force end string
   TRACEE(printf("<<< PH_Reader readInto\n\n");)
   return rc;
}
//--------------------------------------------------------------------
- (int) closeFile
{
   //If fileStatus is not 1 no files are open - close command is
   //illogic

   if(fileStatus != 1) return -3;                    //No files open
   fclose(filePtr);
   fileStatus = 0;                                   //Reader available
   return 0;
}
//--------------------------------------------------------------------
@end


