// Shop.m
//--------------------------------------------------------------------

#import "Shop.h"

//--------------------------------------------------------------------

@implementation Shop

//--------------------------------------------------------------------
//here we set initial values of several variables

- createEnd
{

   id  obj;
   int i;

TRACE2(printf("\n%8X Shop - entry createEnd\n",self);)

   eyeCatcher[0]='S';
   eyeCatcher[1]='H';
   eyeCatcher[2]='O';
   eyeCatcher[3]='P';

   for(i=0;i<256;i++) oldProfit[i] = 0;
   steps = sectorialMeanProfit = sectorialMaxProfit = 0;
   obj = [super createEnd];

TRACE2(printf("%8X Shop - exit createEnd %8X\n\n",self,obj);)

   return obj;

}

//--------------------------------------------------------------------

- setNumberOfAgent: (int) nA
{

TRACE2(printf("\n%8X Shop - entry setNumberOfAgent %d\n",
       self,nA);)

   numberOfAgent = nA;

TRACE2(printf("%8X Shop - exit setNumberOfAgent %8X\n\n",
       self,self);)

   return self;

}

//--------------------------------------------------------------------

- setMemory: (int) me
{

TRACE2(printf("\n%8X Shop - entry setMemory %d\n",
       self,me);)

   memory = me;

TRACE2(printf("%8X Shop - exit setMemory %8X\n\n",
       self,self);)

   return self;

}

//--------------------------------------------------------------------

- setPriceOf: (int) sN to: (int) sP
{

TRACE2(printf("\n%8X Shop - entry setPriceOf %d\n",
       self,sN);)
TRACE2(printf("                                to %d\n",
       self,sP);)

   pricelist[sN] = sP;
   sell[sN]      = 0;

TRACE2(printf("%8X Shop - exit setPriceOf: %8X\n\n",
       self,self);)

   return self;

}

//--------------------------------------------------------------------

- setProfitOf: (int) sN to: (int) sP
{

TRACE2(printf("\n%8X Shop - entry setProfitOf %d\n",
       self,sN);)
TRACE2(printf("                                to %d\n",
       self,sP);)

   profit[sN] = sP;

TRACE2(printf("%8X Shop - exit setProfitOf: %8X\n\n",
       self,self);)

   return self;

}

//--------------------------------------------------------------------

- (int) getPriceOf: (int) sN
{

   int i;

TRACE2(printf("\n%8X Shop - entry getPriceOf %d\n",
       self,sN);)

   i = pricelist[sN];

TRACE2(printf("%8X Shop - exit getPriceOf: %d\n\n",
       self,i);)

   return i;

}

//--------------------------------------------------------------------

- (int) getSectorialMeanProfit
{

TRACE2(printf("\n%8X Shop - entry getSectorialMeanProfit\n",
              self);)
TRACE2(printf("%8X Shop - exit getSectorialMeanProfit %d\n\n",
              self,sectorialMeanProfit);)

   return sectorialMeanProfit;

}

//--------------------------------------------------------------------

- (int) getSectorialMaxProfit
{

TRACE2(printf("\n%8X Shop - entry getSectorialMaxProfit\n",
              self);)
TRACE2(printf("%8X Shop - exit getSectorialMaxProfit %d\n\n",
              self,sectorialMaxProfit);)

   return sectorialMaxProfit;

}

//--------------------------------------------------------------------

- (int) getSellOf: (int) sN
{

   int i;

TRACE2(printf("\n%8X Shop - entry getSellOf %d\n",
              self,sN);)

   i = sell[sN];

TRACE2(printf("%8X Shop - exit getSellOf: %d\n\n",
              self,i);)

   return i;

}

//--------------------------------------------------------------------

- sell: (int) qq of: (int) sN
{

TRACE2(printf("\n%8X Shop - entry sell: %d\n",
              self,qq);)
TRACE2(printf("                        of: %d\n",
              self,sN);)

   sell[sN] = sell[sN] + qq;

TRACE2(printf("%8X Shop - exit sell %8X\n\n",
              self,self);)

   return self;

}

//--------------------------------------------------------------------

- computeSectorialData
{

   int i,s=0;

TRACE2(printf("\n%8X Shop - entry computeSectorialData\n",self);)

   for(i=0;i<numberOfAgent;i++) s = s + profit[i];

   sumProfit = sumProfit - oldProfit[steps % memory] + s;
   oldProfit[steps % memory] = s;
   steps++;

   s = s / numberOfAgent;
   if (s > sectorialMaxProfit) sectorialMaxProfit = s;

   if (steps > memory)
      sectorialMeanProfit = sumProfit / (memory * numberOfAgent);
   else
      sectorialMeanProfit = sumProfit / (steps  * numberOfAgent);

TRACE2(printf("%8X Shop - exit computeSectorialData\n\n",
              self,self);)

   return self;

}

//--------------------------------------------------------------------

@end

